diff --git a/tests/convert-tests/001-ext2-backup-superblock-ranges/drdhdhdrd.e2image.raw.xz b/tests/convert-tests/001-ext2-backup-superblock-ranges/drdhdhdrd.e2image.raw.xz
new file mode 100644
index 0000000000000000000000000000000000000000..73e2309c4bd6991424962c3bc53ad74171b52268
GIT binary patch
diff --git a/tests/convert-tests/001-ext2-backup-superblock-ranges/drdhdhrh.e2image.raw.xz b/tests/convert-tests/001-ext2-backup-superblock-ranges/drdhdhrh.e2image.raw.xz
new file mode 100644
index 0000000000000000000000000000000000000000..0d5442fffcd8106ed1fda52b317d0f4c3612fbe5
GIT binary patch
diff --git a/tests/convert-tests/001-ext2-backup-superblock-ranges/hrhdhdrd.e2image.raw.xz b/tests/convert-tests/001-ext2-backup-superblock-ranges/hrhdhdrd.e2image.raw.xz
new file mode 100644
index 0000000000000000000000000000000000000000..a1a304295f8c894a5db4b63dacbd3eb2fbc8420f
GIT binary patch
diff --git a/tests/convert-tests/001-ext2-backup-superblock-ranges/hrhdhrh.e2image.raw.xz b/tests/convert-tests/001-ext2-backup-superblock-ranges/hrhdhrh.e2image.raw.xz
new file mode 100644
index 0000000000000000000000000000000000000000..ac0dbc60ee6b0f8c374066c822b65d827c4a4da6
GIT binary patch
diff --git a/tests/convert-tests/001-ext2-backup-superblock-ranges/test.sh b/tests/convert-tests/001-ext2-backup-superblock-ranges/test.sh
new file mode 100755
index 0000000..5d1bce3
--- /dev/null
+++ b/tests/convert-tests/001-ext2-backup-superblock-ranges/test.sh
@@ -0,0 +1,37 @@
+#!/bin/bash
+
+# Specially created e2image dump to test backup superblock migration for
+# new convert.
+# These images will cause the following problems if convert doesn't handle
+# backup superblock migration well:
+# 1) Assert while building free space tree
+# 2) Error copying inodes
+# 3) Discontinuous file extents after convert
+# 4) Overlap file extents
+# 5) Unable to rollback
+
+source $TOP/tests/common
+
+check_prereq btrfs-convert
+check_prereq btrfs
+check_prereq btrfs-show-super
+check_global_prereq e2fsck
+check_global_prereq xzcat
+
+prepare_test_dev 512M
+for src in $(find . -iname "*.e2image.raw.xz"); do
+	extracted=$(extract_image "$src")
+	run_check $SUDO_HELPER e2fsck -n -f $extracted
+	run_check $SUDO_HELPER $TOP/btrfs-convert $extracted
+	run_check $SUDO_HELPER $TOP/btrfs check $extracted
+	run_check $SUDO_HELPER $TOP/btrfs-show-super $extracted
+
+	run_check $SUDO_HELPER mount -o loop $extracted $TEST_MNT
+	run_check $SUDO_HELPER e2fsck -n -f $TEST_MNT/ext2_saved/image
+	run_check $SUDO_HELPER umount $TEST_MNT
+
+	run_check $SUDO_HELPER $TOP/btrfs check $extracted
+	run_check $SUDO_HELPER $TOP/btrfs-convert -r $extracted
+	run_check $SUDO_HELPER e2fsck -n -f $extracted
+	rm -f $extracted
+done